glibmm: Gio::NetworkAddress Class Reference

glibmm 2.72.1

Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Gio::NetworkAddress Class Reference
Portable Network I/O Functionality

A SocketConnectable for resolving hostnames. More...

`#include <giomm/networkaddress.h>`

Inheritance diagram for Gio::NetworkAddress:
[legend]

## Public Member Functions
| NetworkAddress (NetworkAddress && src) noexcept
NetworkAddress & | operator= (NetworkAddress && src) noexcept
| ~NetworkAddress () noexcept override
GNetworkAddress * | gobj ()
| Provides access to the underlying C GObject. More...
const GNetworkAddress * | gobj () const
| Provides access to the underlying C GObject. More...
GNetworkAddress * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
std::string | get_hostname () const
| Gets addr's hostname. More...
guint16 | get_port () const
| Gets addr's port number. More...
std::string | get_scheme () const
| Gets addr's scheme. More...
Glib::PropertyProxy_ReadOnly< std::string > | property_hostname () const
| Hostname to resolve. More...
Glib::PropertyProxy_ReadOnly< guint > | property_port () const
| Network port. More...
Glib::PropertyProxy_ReadOnly< std::string > | property_scheme () const
| URI Scheme. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void *data)
void | set_data (const Quark & key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark & quark)
void * | steal_data (const QueryQuark & quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
PropertyType | get_property (const Glib::ustring & property_name) const
| You probably want to use a specific property_*() accessor method instead. More...
sigc::connection | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void()> & slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void()> && slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject * | gobj ()
| Provides access to the underlying C GObject. More...
const GObject * | gobj () const
| Provides access to the underlying C GObject. More...
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gio::SocketConnectable
| SocketConnectable (SocketConnectable && src) noexcept
SocketConnectable & | operator= (SocketConnectable && src) noexcept
| ~SocketConnectable () noexcept override
GSocketConnectable * | gobj ()
| Provides access to the underlying C GObject. More...
const GSocketConnectable * | gobj () const
| Provides access to the underlying C GObject. More...
Glib::RefPtr< SocketAddressEnumerator > | enumerate ()
| Creates a SocketAddressEnumerator for connectable. More...
Glib::RefPtr< const SocketAddressEnumerator > | enumerate () const
| Creates a SocketAddressEnumerator for connectable. More...
Glib::RefPtr< SocketAddressEnumerator > | proxy_enumerate ()
| Creates a SocketAddressEnumerator for connectable that will return a ProxyAddress for each of its addresses that you must connect to via a proxy. More...
Glib::RefPtr< const SocketAddressEnumerator > | proxy_enumerate () const
| Creates a SocketAddressEnumerator for connectable that will return a ProxyAddress for each of its addresses that you must connect to via a proxy. More...
Glib::ustring | to_string () const
| Format a SocketConnectable as a string. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor. More...
| Interface (Interface && src) noexcept
Interface & | operator= (Interface && src) noexcept
| Interface (const Glib::Interface_Class & interface_class)
| Called by constructors of derived classes. More...
| Interface (GObject * castitem)
| Called by constructors of derived classes. More...
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< NetworkAddress > | create (const std::string & hostname, guint16 port)
static Glib::RefPtr< NetworkAddress > | parse (const std::string & host_and_port, guint16 default_port)
Static Public Member Functions inherited from Gio::SocketConnectable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::NetworkAddress > | wrap (GNetworkAddress * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject * object, bool take_copy=false)
Related Functions inherited from Gio::SocketConnectable
Glib::RefPtr< Gio::SocketConnectable > | wrap (GSocketConnectable * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams & construct_params)
| Object (GObject * castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char * custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info & custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase && src) noexcept
ObjectBase & | operator= (ObjectBase && src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject * castitem)
void | initialize_move (GObject * castitem, Glib::ObjectBase * previous_wrapper)
Protected Member Functions inherited from Gio::SocketConnectable
| SocketConnectable ()
| You should derive from this class to use it. More...

## Detailed Description

A SocketConnectable for resolving hostnames.

NetworkAddress provides an easy way to resolve a hostname and then attempt to connect to that host, handling the possibility of multiple IP addresses and multiple address families.

Since glibmm 2.24:

## Constructor & Destructor Documentation

## ◆ NetworkAddress()

Gio::NetworkAddress::NetworkAddress | ( | NetworkAddress && | src | ) |
| noexcept

## ◆ ~NetworkAddress()

Gio::NetworkAddress::~NetworkAddress | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ create()

static Glib::RefPtr<NetworkAddress> Gio::NetworkAddress::create | ( | const std::string & | hostname,
|  | guint16 | port
| ) |  |
| static

## ◆ get_hostname()

std::string Gio::NetworkAddress::get_hostname | ( |  | ) | const

Gets addr's hostname.

This might be either UTF-8 or ASCII-encoded, depending on what addr was created with.

Since glibmm 2.22:

Returns
  addr's hostname.

## ◆ get_port()

guint16 Gio::NetworkAddress::get_port | ( |  | ) | const

Gets addr's port number.

Since glibmm 2.22:

Returns
  addr's port (which may be 0).

## ◆ get_scheme()

std::string Gio::NetworkAddress::get_scheme | ( |  | ) | const

Gets addr's scheme.

Since glibmm 2.26:

Returns
  addr's scheme (`nullptr` if not built from URI).

## ◆ get_type()

static GType Gio::NetworkAddress::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GNetworkAddress* Gio::NetworkAddress::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GNetworkAddress* Gio::NetworkAddress::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GNetworkAddress* Gio::NetworkAddress::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

NetworkAddress& Gio::NetworkAddress::operator= | ( | NetworkAddress && | src | ) |
| noexcept

## ◆ parse()

static Glib::RefPtr<NetworkAddress> Gio::NetworkAddress::parse | ( | const std::string & | host_and_port,
|  | guint16 | default_port
| ) |  |
| static

## ◆ property_hostname()

Glib::PropertyProxy_ReadOnly< std::string > Gio::NetworkAddress::property_hostname | ( |  | ) | const

Hostname to resolve.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_port()

Glib::PropertyProxy_ReadOnly< guint > Gio::NetworkAddress::property_port | ( |  | ) | const

Network port.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_scheme()

Glib::PropertyProxy_ReadOnly< std::string > Gio::NetworkAddress::property_scheme | ( |  | ) | const

URI Scheme.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gio::NetworkAddress > wrap | ( | GNetworkAddress * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.